/*  Copyright 2005, Craig Andrews, Mike Itz, Martin Meyer
 
    This file is part of "Natural Language Interface Using First Order Logic"

    "Natural Language Interface Using First Order Logic" is free software;
    you can redistribute it and/or modify it under the terms of the GNU
    General Public License as published by the Free Software Foundation;
    either version 2 of the License, or (at your option) any later version.

    "Natural Language Interface Using First Order Logic" is distributed
    in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
    even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
    PURPOSE.  See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
package lojban.analyzer;

import java.util.Map;
import java.util.Set;

import lojban.agent.KnowledgeBaseException;

public interface IKnowledgeBase {
	/**Tell the knowledgebase that a given fact holds
	 * @param fact
	 * @throws KnowledgeBaseException
	 */
	public void tell(IFact fact) throws KnowledgeBaseException;
	
	/**Ask
	 * @param fact with query subjects in it
	 * @param multiple if false, return at most one answer
	 * @return a set of maps mapping a query subject to all the values it can have in that answer. Each map represents a complete answer.
	 * @throws KnowledgeBaseException
	 */
	public Set<Map<ISubject, ISubject[]>> ask(IFact fact, boolean multiple) throws KnowledgeBaseException;
}
