/*  Copyright 2005, Craig Andrews, Mike Itz, Martin Meyer
 
    This file is part of "Natural Language Interface Using First Order Logic"

    "Natural Language Interface Using First Order Logic" is free software;
    you can redistribute it and/or modify it under the terms of the GNU
    General Public License as published by the Free Software Foundation;
    either version 2 of the License, or (at your option) any later version.

    "Natural Language Interface Using First Order Logic" is distributed
    in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
    even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
    PURPOSE.  See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
package lojban.analyzer;

public interface ISubject {
	
	/**Is this a literal subject (like arthur)
	 * @return true if this is a literal subject
	 */
	public boolean isLiteral();
	
	/**Is this a subject which is a reference like ?q1 or s0
	 * @return true if this is a reference
	 */
	public boolean isIdentifier();
	
	/**
	 * @return true if a fact restricts this subject
	 */
	public boolean isRestricted();
	
	/**
	 * @return the facts which restrict this subject (or null)
	 */
	public IFact getRestricting();
	
	/**
	 * @return the subject which replaces this one in the restricting fact
	 */
	public ISubject getRestrictingIdentifier();
	
	/**
	 * @return true if the subject is a prosumti
	 */
	public boolean isProsumti();
}
