/*  Copyright 2005, Craig Andrews, Mike Itz, Martin Meyer
 
    This file is part of "Natural Language Interface Using First Order Logic"

    "Natural Language Interface Using First Order Logic" is free software;
    you can redistribute it and/or modify it under the terms of the GNU
    General Public License as published by the Free Software Foundation;
    either version 2 of the License, or (at your option) any later version.

    "Natural Language Interface Using First Order Logic" is distributed
    in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
    even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
    PURPOSE.  See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
package lojban.gui;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.net.MalformedURLException;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.Timer;
import javax.swing.text.html.HTMLDocument;

public class About extends JDialog implements ActionListener {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	Timer scrollTimer;
	
	JScrollPane scroll;
	JEditorPane people;
	JButton closeButton;

	public About(JFrame parent){
		//set up the dialog
		super(parent,"A Natural Language Interface Using First Order Logic");
		this.setSize(600,400);
		
		//the main frame
		JPanel main = new JPanel();
		this.getContentPane().add(main);
		main.setLayout(new BorderLayout());
		closeButton=new JButton("Close");
		closeButton.addActionListener(this);
		main.add(closeButton,BorderLayout.SOUTH);
		
		//now for the cool part
		JPanel upper = new JPanel();
		main.add(upper,BorderLayout.CENTER);
		upper.setLayout(new BorderLayout());
		
		JLabel logo=new JLabel(new ImageIcon("lojban/gui/lojban.png"));
		upper.add(logo, BorderLayout.LINE_START);
		File f=new File("lojban/gui/lojban.png");
		try {
			people = new JEditorPane("text/html","<html><center><br><big>A Natural Language Interface Using First Order Logic</big><br>" +
					"A Major Qualifying Project <i>for</i> Worcester Polytechnic Institute<hr><br>" +
					"<table border=0>" +
					"<tr><td>Craig Andrews</td><td><img src=\"craig.jpg\"></td></tr>" +
					"<tr><td>Mike Itz</td><td><img src=\"mike.jpg\"></td></tr>" +
					"<tr><td>Martin Meyer</td><td><img src=\"martin.jpg\"></td></tr>" +
					"</table>" +
					"<br>Advised by:<br>Professor Dan Dougherty<br>Professor Gary Pollice<br><br>" +
					"This application is copyrighted by Craig Andrews, Mike Itz, and Martin Meyer.<br>" +
					"It is released under the GNU GPL. See &quot;README&quot; for more information.<br>" +
					"Code from FreeTTS, JTP, and other projects is included. Please see their websites for their particular license requirements.</center></html>");
			((HTMLDocument) people.getDocument()).setBase(f.getParentFile().toURL());
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		people.setEditable(false);
		people.setOpaque(false);
		people.setCaretPosition(0);
		scroll = new JScrollPane(people,JScrollPane.VERTICAL_SCROLLBAR_NEVER,JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		upper.add(scroll, BorderLayout.CENTER);
		
		this.setVisible(true);
		scrollTimer = new Timer(100, this);
		scrollTimer.start();
	}

	public void actionPerformed(ActionEvent ae) {
		if(ae.getSource()==closeButton){
			this.dispose();
		}
		if(ae.getSource() == scrollTimer){
			if(people.getY()*-1>people.getHeight()){
				System.out.println("resetting");
				people.setBounds(people.getX(),scroll.getViewport().getHeight(),people.getWidth(),people.getHeight());
			}else{
				people.setBounds(people.getX(),people.getY()-1,people.getWidth(),people.getHeight());
			}

		}
	}
}
