/*  Copyright 2005, Craig Andrews, Mike Itz, Martin Meyer
 
    This file is part of "Natural Language Interface Using First Order Logic"

    "Natural Language Interface Using First Order Logic" is free software;
    you can redistribute it and/or modify it under the terms of the GNU
    General Public License as published by the Free Software Foundation;
    either version 2 of the License, or (at your option) any later version.

    "Natural Language Interface Using First Order Logic" is distributed
    in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
    even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
    PURPOSE.  See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
package lojban.gui;

import lojban.agent.IConversationListener;
import lojban.agent.LojbanContext;
import lojban.agent.LojbanPlugin;

public class StdOutPlugin implements LojbanPlugin, IConversationListener {

	private LojbanContext lc;

	public void load(LojbanContext lc) {
		this.lc = lc;
		lc.addConversationListener(this);
	}

	public void unload() {
		lc.removeConversationListener(this);
	}

	public String getPluginName() {
		return "Standard Out";
	}

	public void input(String s) {
		System.out.println("< " + s);
	}

	public void output(String s) {
		System.out.println("*" + s);
	}

	public void error(String s) {
		System.out.println("ERR: error after \"" + s + "\"");
	}

	public void status(String s) {
		
	}

}
