/*  Copyright 2005, Craig Andrews, Mike Itz, Martin Meyer
 
    This file is part of "Natural Language Interface Using First Order Logic"

    "Natural Language Interface Using First Order Logic" is free software;
    you can redistribute it and/or modify it under the terms of the GNU
    General Public License as published by the Free Software Foundation;
    either version 2 of the License, or (at your option) any later version.

    "Natural Language Interface Using First Order Logic" is distributed
    in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
    even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
    PURPOSE.  See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
package lojban.kb.jtp;

import lojban.analyzer.IFact;
import lojban.analyzer.ISubject;

public abstract class JTPSubject implements ISubject {
	
	/* (non-Javadoc)
	 * @see lojban.analyzer.ISubject#isLiteral()
	 */
	public boolean isLiteral(){
		return false;
	}
	
	/**
	 * @return any late subjects which are children of this subject
	 */
	public abstract JTPLateSubject[] getLateSubjects();

	/**
	 * @param id some id string
	 * @return true if this id string refers to this subject
	 */
	public abstract boolean matchesId(JTPSubject id);
	
	/* (non-Javadoc)
	 * @see lojban.analyzer.ISubject#isIdentifier()
	 */
	public boolean isIdentifier() {
		return false;
	}
	
	/* (non-Javadoc)
	 * @see lojban.analyzer.ISubject#isRestricted()
	 */
	public boolean isRestricted() {
		return false;
	}
	
	/* (non-Javadoc)
	 * @see lojban.analyzer.ISubject#getRestrictions()
	 */
	public IFact getRestricting() {
		return null;
	}
	
	/* (non-Javadoc)
	 * @see lojban.analyzer.ISubject#getRestrictingIdentifier()
	 */
	public ISubject getRestrictingIdentifier() {
		return null;
	}
	
	public boolean isProsumti() {
		return false;
	}
}
