/*  Copyright 2005, Craig Andrews, Mike Itz, Martin Meyer
 
    This file is part of "Natural Language Interface Using First Order Logic"

    "Natural Language Interface Using First Order Logic" is free software;
    you can redistribute it and/or modify it under the terms of the GNU
    General Public License as published by the Free Software Foundation;
    either version 2 of the License, or (at your option) any later version.

    "Natural Language Interface Using First Order Logic" is distributed
    in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
    even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
    PURPOSE.  See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
package textToSpeech.voice;

import java.util.Locale;

import com.sun.speech.freetts.Age;
import com.sun.speech.freetts.Gender;
import com.sun.speech.freetts.Voice;
import com.sun.speech.freetts.VoiceDirectory;

public class LojbanDirectory extends VoiceDirectory {

	//@Override
	public Voice[] getVoices() {
		
		// use our custom lexicon
		LojbanLexicon lexicon = new LojbanLexicon("cmulex");
		
		// but use a standard CMUDiphoneVoice (maybe replace for better tokenization/stress/etc later)
        Voice kat = new LojbanDiphoneVoice("lojban", Gender.MALE,
                Age.YOUNGER_ADULT, "default 16-bit diphone voice",
                Locale.US, "general", "cmu", lexicon,
                this.getClass().getResource("/com/sun/speech/freetts/en/us/cmu_us_kal/cmu_us_kal16.bin"));

        Voice[] voices = {kat};
        return voices;
	}

}
